﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace sms
{
    class Hivas
    {
        int ora, perc;
        string szam, uzenet;
        int hossz;
        public int Ora { get { return ora; } set { ora = value; } }
        public int Perc { get { return perc; } set { perc = value; } }
        public int Hossz { get { return hossz; } set { perc = hossz; } }
        public string Szam { get { return szam; } set { szam = value; } }
        public string Uzenet { get { return uzenet; } set { uzenet = value; } }
        public Hivas(string szamok, string szoveg)
        {
            string[] sz = new string[3];
            sz = szamok.Split(' ');
            ora = Convert.ToInt32(sz[0]);
            perc = Convert.ToInt32(sz[1]);
            szam = sz[2];
            uzenet = szoveg;
            hossz = uzenet.Length;
        }
        public Hivas() { }
    }

    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat - beolvasás
            StreamReader be = new StreamReader("sms.txt");
            int N = Convert.ToInt32(be.ReadLine());
            Hivas[] SMS = new Hivas[N + 1];
            for (int i = 0; i < N; i++)
            {
                SMS[i] = new Hivas(be.ReadLine(), be.ReadLine());
            }
            be.Close();
            #endregion
            #region 2. feladat - legfrissebb üzi
            Console.WriteLine("2. feladat");
            if (N < 10)
            {
                Console.WriteLine(SMS[N - 1].Uzenet);
            }
            else
            {
                Console.WriteLine(SMS[9].Uzenet);
            }
            #endregion
            #region 3. feladat - üzenethosszak
            Console.WriteLine("3. feladat");
            int max = 0; ;
            int min = max;
            for (int i = 1; i < N; i++)
            {
                if (SMS[i].Hossz > SMS[max].Hossz)
                {
                    max = i;
                }
                if (SMS[i].Hossz < SMS[min].Hossz)
                {
                    min = i;
                }
            }
            Console.WriteLine("A leghosszabb üzenet {0}:{1}-kor, a {2} számról: {3}", SMS[max].Ora, SMS[max].Perc, SMS[max].Szam, SMS[max].Uzenet);
            Console.WriteLine("A legrövidebb üzenet {0}:{1}-kor, a {2} számról: {3}", SMS[min].Ora, SMS[min].Perc, SMS[min].Szam, SMS[min].Uzenet);
            #endregion
            #region 4. feladat - hosszkategóriák
            Console.WriteLine("4. feladat");
            int[] méret = new int[5];
            for (int i = 0; i < N; i++)
            {
                méret[(SMS[i].Hossz - 1) / 20]++;
            }
            for (int i = 0; i < 5; i++)
            {
                Console.WriteLine("{0}-{1} hosszú üzenet: {2} db", i * 20 + 1, i * 20 + 20, méret[i]);
            }
            #endregion
            #region 5. feladat - tulcsordulás db
            Console.WriteLine("5. feladat");
            int oradb = 1;
            int db = 0;
            for (int i = 1; i < N; i++)
            {
                if (SMS[i - 1].Ora == SMS[i].Ora)
                {
                    oradb++;
                }
                else
                {
                    db += oradb > 10 ? oradb - 10 : 0;
                    oradb = 1;
                }
            }
            Console.WriteLine("különhívásos üzenetek száma: {0}", db);

            #endregion
            #region 6. feladat - max szunet
            Console.WriteLine("6. feladat");
            int l = 0;
            while (l < N && SMS[l].Szam != "123456789")
            {
                l++;
            }
            if (l == N)
            {
                Console.WriteLine("Nincs elegendő üzenet");
            }
            else
            {
                int szunet = 0;
                int start = l;
                int end = l;
                for (int j = l + 1; j < N; j++)
                {
                    if (SMS[j].Szam == "123456789")
                    {
                        if ((SMS[j].Ora - SMS[start].Ora) * 60 + SMS[j].Perc - SMS[start].Perc > szunet)
                        {
                            szunet = (SMS[j].Ora - SMS[start].Ora) * 60 + SMS[j].Perc - SMS[start].Perc;

                        }
                        start = j;
                    }
                }
                if (szunet == 0)
                {
                    Console.WriteLine("Nincs elegendő üzenet");
                }
                else
                {
                    Console.WriteLine(szunet+" perc");
                }
            }
            #endregion
            #region 7. feladat - új adat
            Console.WriteLine("7. feladat");
            Console.Write("Adja meg a hívás adatait: ");
            string adatok =  Console.ReadLine();
            Console.Write("Adja meg az üzenet szövegét: ");
            string uzenet =  Console.ReadLine();
            SMS[N] = new Hivas(adatok, uzenet);
            #endregion
            #region 8. feladat - rendezett kiírás
            Console.WriteLine("8. feladat");
            Hivas hely = new Hivas();
            for (int i = 0; i < N; i++)
            {
                min = i;
                for (int j = i+1; j < N+1; j++)
                {
                    if (SMS[min].Szam.CompareTo(SMS[j].Szam) == 1)
                    {
                        min = j;
                    } 
                }
                hely = SMS[min];
                SMS[min] = SMS[i];
                SMS[i] = hely;
            }
            StreamWriter ki = new StreamWriter("smski.txt");
            ki.WriteLine(SMS[0].Szam+"\r\n\t"+SMS[0].Ora+":"+SMS[0].Perc+" "+SMS[0].Uzenet);
            for (int i = 1; i < N+1; i++)
            {
                if (SMS[i].Szam != SMS[i-1].Szam)
                {
                    ki.WriteLine(SMS[i].Szam);
                }
                ki.WriteLine("\t" + SMS[i].Ora + ":" + SMS[i].Perc + " " + SMS[i].Uzenet);
            }
            ki.Close();
            Console.WriteLine("A kiírás befejezve.");
            #endregion
            Console.ReadLine();
        }
    }
}
